var Ke = (t, e, n) => {
  if (!e.has(t))
    throw TypeError("Cannot " + n);
}, S = (t, e, n) => (Ke(t, e, "read from private field"), n ? n.call(t) : e.get(t)), Rt = (t, e, n) => {
  if (e.has(t))
    throw TypeError("Cannot add the same private member more than once");
  e instanceof WeakSet ? e.add(t) : e.set(t, n);
}, nt = (t, e, n, i) => (Ke(t, e, "write to private field"), i ? i.call(t, n) : e.set(t, n), n), q;
let Cn = class {
  constructor(e, n) {
    Rt(this, q, void 0), this.value = e, nt(this, q, n), this.mql = null;
  }
  get handler() {
    return S(this, q);
  }
  // Unmount existing handler before setting a new one.
  set handler(e) {
    this.mql && (typeof this.mql.removeEventListener == "function" ? this.mql.removeEventListener("change", S(this, q)) : this.mql.removeListener(S(this, q))), nt(this, q, e);
  }
  mount(e, n) {
    return e && (this.value = e), n && nt(this, q, n), this.value ? (this.mql = window.matchMedia(`(min-width: ${this.value})`), typeof this.mql.addEventListener == "function" ? this.mql.addEventListener("change", S(this, q)) : this.mql.addListener(S(this, q)), S(this, q).call(this, this.mql), this) : this;
  }
  unmount() {
    return this.mql ? (typeof this.mql.removeEventListener == "function" ? this.mql.removeEventListener("change", S(this, q)) : this.mql.removeListener(S(this, q)), this.value = null, nt(this, q, null), this.mql = null, this) : this;
  }
};
q = /* @__PURE__ */ new WeakMap();
let In = class {
  constructor() {
    this.collection = [];
  }
  async register(e) {
    return await this.deregister(e), this.collection.push(e), this.collection;
  }
  async deregister(e) {
    const n = this.collection.findIndex((i) => i === e);
    if (n >= 0) {
      const i = this.collection[n];
      Object.getOwnPropertyNames(i).forEach((s) => {
        delete i[s];
      }), this.collection.splice(n, 1);
    }
    return this.collection;
  }
  async registerCollection(e) {
    return await Promise.all(Array.from(e, (n) => {
      this.register(n);
    })), this.collection;
  }
  async deregisterCollection() {
    for (; this.collection.length > 0; )
      await this.deregister(this.collection[0]);
    return this.collection;
  }
  get(e, n = "id") {
    return this.collection.find((i) => i[n] === e);
  }
};
const p = {
  inert: ":not([inert]):not([inert] *)",
  negTabIndex: ':not([tabindex^="-"])',
  disabled: ":not(:disabled)"
}, Sn = [
  `a[href]${p.inert}${p.negTabIndex}`,
  `area[href]${p.inert}${p.negTabIndex}`,
  `input:not([type="hidden"]):not([type="radio"])${p.inert}${p.negTabIndex}${p.disabled}`,
  `input[type="radio"]${p.inert}${p.negTabIndex}${p.disabled}`,
  `select${p.inert}${p.negTabIndex}${p.disabled}`,
  `textarea${p.inert}${p.negTabIndex}${p.disabled}`,
  `button${p.inert}${p.negTabIndex}${p.disabled}`,
  `details${p.inert} > summary:first-of-type${p.negTabIndex}`,
  // Discard until Firefox supports `:has()`
  // See: https://github.com/KittyGiraudel/focusable-selectors/issues/12
  // `details:not(:has(> summary))${not.inert}${not.negTabIndex}`,
  `iframe${p.inert}${p.negTabIndex}`,
  `audio[controls]${p.inert}${p.negTabIndex}`,
  `video[controls]${p.inert}${p.negTabIndex}`,
  `[contenteditable]${p.inert}${p.negTabIndex}`,
  `[tabindex]${p.inert}${p.negTabIndex}`
];
var wt, at, lt;
let Dn = class {
  constructor(e = null, n = "[data-focus]") {
    Rt(this, wt, void 0), Rt(this, at, void 0), Rt(this, lt, void 0), this.el = e, this.selectorFocus = n, nt(this, at, Pn.bind(this)), nt(this, lt, qn.bind(this));
  }
  get focusable() {
    return S(this, wt);
  }
  set focusable(e) {
    nt(this, wt, e), S(this, wt).length ? (document.removeEventListener("keydown", S(this, lt)), document.addEventListener("keydown", S(this, at))) : (document.removeEventListener("keydown", S(this, at)), document.addEventListener("keydown", S(this, lt)));
  }
  get focusableFirst() {
    return this.focusable[0];
  }
  get focusableLast() {
    return this.focusable[this.focusable.length - 1];
  }
  mount(e, n) {
    e && (this.el = e), n && (this.selectorFocus = n), this.focusable = this.getFocusable(), this.focus();
  }
  unmount() {
    this.el = null, this.focusable = [], document.removeEventListener("keydown", S(this, at)), document.removeEventListener("keydown", S(this, lt));
  }
  focus(e = this.el, n = this.selectorFocus) {
    (e.querySelector(n) || e).focus();
  }
  getFocusable(e = this.el) {
    const n = [], i = document.activeElement, s = e.scrollTop;
    return e.querySelectorAll(Sn.join(",")).forEach((r) => {
      r.focus(), document.activeElement === r && n.push(r);
    }), e.scrollTop = s, i.focus(), n;
  }
};
wt = /* @__PURE__ */ new WeakMap(), at = /* @__PURE__ */ new WeakMap(), lt = /* @__PURE__ */ new WeakMap();
function Pn(t) {
  (t.key === "Tab" || t.keyCode === 9) && (t.shiftKey ? (document.activeElement === this.focusableFirst || document.activeElement === this.el) && (t.preventDefault(), this.focusableLast.focus()) : (document.activeElement === this.focusableLast || document.activeElement === this.el) && (t.preventDefault(), this.focusableFirst.focus()));
}
function qn(t) {
  (t.key === "Tab" || t.keyCode === 9) && t.preventDefault();
}
function Mn(t, e) {
  const n = (t.getAttribute(`data-${e}`) || "").replace(/'/g, '"');
  return n ? JSON.parse(n) : {};
}
function Wn() {
  return getComputedStyle(document.body).getPropertyValue("--vrembem-variable-prefix").trim();
}
function jn(t, e = !0) {
  const n = localStorage.getItem(t), i = n ? JSON.parse(n) : {};
  return {
    get(s) {
      return s ? i[s] : i;
    },
    set(s, r) {
      return r ? i[s] = r : delete i[s], e && localStorage.setItem(t, JSON.stringify(i)), i;
    }
  };
}
function Nn(t, e, n) {
  const i = e.nodeType === Node.COMMENT_NODE, s = e.nodeType === Node.ELEMENT_NODE;
  if (e = i || s ? e : document.querySelector(e), i && (n = "after"), !e)
    throw new Error(`Not a valid teleport reference: '${e}'`);
  if (typeof e[n] != "function")
    throw new Error(`Not a valid teleport method: '${n}'`);
  let r = null;
  return i || (r = document.createComment("teleported #" + t.id), t.before(r)), e[n](t), i && e.remove(), r;
}
const _n = (t, e) => new Promise((n) => {
  e.transition ? (t.classList.remove(e.stateClosed), t.classList.add(e.stateOpening), t.addEventListener("transitionend", function i(s) {
    s.target == t && (t.classList.add(e.stateOpened), t.classList.remove(e.stateOpening), n(t), this.removeEventListener("transitionend", i));
  })) : (t.classList.add(e.stateOpened), t.classList.remove(e.stateClosed), n(t));
}), Fn = (t, e) => new Promise((n) => {
  e.transition ? (t.classList.add(e.stateClosing), t.classList.remove(e.stateOpened), t.addEventListener("transitionend", function i(s) {
    s.target == t && (t.classList.remove(e.stateClosing), t.classList.add(e.stateClosed), n(t), this.removeEventListener("transitionend", i));
  })) : (t.classList.add(e.stateClosed), t.classList.remove(e.stateOpened), n(t));
});
function Bn(t, e) {
  e && document.querySelectorAll(e).forEach((n) => {
    t ? n.style.overflow = "hidden" : n.style.removeProperty("overflow");
  });
}
function Rn(t, e) {
  e && document.querySelectorAll(e).forEach((n) => {
    t ? (n.inert = !0, n.setAttribute("aria-hidden", !0)) : (n.inert = null, n.removeAttribute("aria-hidden"));
  });
}
function Hn(t, e) {
  Rn(!!t, e.selectorInert), Bn(!!t, e.selectorOverflow);
}
const Gs = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  Breakpoint: Cn,
  Collection: In,
  FocusTrap: Dn,
  closeTransition: Fn,
  getConfig: Mn,
  getPrefix: Wn,
  localStore: jn,
  openTransition: _n,
  teleport: Nn,
  updateGlobalState: Hn
}, Symbol.toStringTag, { value: "Module" }));
var Ge = (t, e, n) => {
  if (!e.has(t))
    throw TypeError("Cannot " + n);
}, _t = (t, e, n) => (Ge(t, e, "read from private field"), n ? n.call(t) : e.get(t)), De = (t, e, n) => {
  if (e.has(t))
    throw TypeError("Cannot add the same private member more than once");
  e instanceof WeakSet ? e.add(t) : e.set(t, n);
}, Pe = (t, e, n, i) => (Ge(t, e, "write to private field"), i ? i.call(t, n) : e.set(t, n), n), Qe = (t, e, n) => {
  if (!e.has(t))
    throw TypeError("Cannot " + n);
}, D = (t, e, n) => (Qe(t, e, "read from private field"), n ? n.call(t) : e.get(t)), Ht = (t, e, n) => {
  if (e.has(t))
    throw TypeError("Cannot add the same private member more than once");
  e instanceof WeakSet ? e.add(t) : e.set(t, n);
}, it = (t, e, n, i) => (Qe(t, e, "write to private field"), i ? i.call(t, n) : e.set(t, n), n), M;
let Vn = class {
  constructor(e, n) {
    Ht(this, M, void 0), this.value = e, it(this, M, n), this.mql = null;
  }
  get handler() {
    return D(this, M);
  }
  // Unmount existing handler before setting a new one.
  set handler(e) {
    this.mql && (typeof this.mql.removeEventListener == "function" ? this.mql.removeEventListener("change", D(this, M)) : this.mql.removeListener(D(this, M))), it(this, M, e);
  }
  mount(e, n) {
    return e && (this.value = e), n && it(this, M, n), this.value ? (this.mql = window.matchMedia(`(min-width: ${this.value})`), typeof this.mql.addEventListener == "function" ? this.mql.addEventListener("change", D(this, M)) : this.mql.addListener(D(this, M)), D(this, M).call(this, this.mql), this) : this;
  }
  unmount() {
    return this.mql ? (typeof this.mql.removeEventListener == "function" ? this.mql.removeEventListener("change", D(this, M)) : this.mql.removeListener(D(this, M)), this.value = null, it(this, M, null), this.mql = null, this) : this;
  }
};
M = /* @__PURE__ */ new WeakMap();
let Jn = class {
  constructor() {
    this.collection = [];
  }
  async register(e) {
    return await this.deregister(e), this.collection.push(e), this.collection;
  }
  async deregister(e) {
    const n = this.collection.findIndex((i) => i === e);
    if (n >= 0) {
      const i = this.collection[n];
      Object.getOwnPropertyNames(i).forEach((s) => {
        delete i[s];
      }), this.collection.splice(n, 1);
    }
    return this.collection;
  }
  async registerCollection(e) {
    return await Promise.all(Array.from(e, (n) => {
      this.register(n);
    })), this.collection;
  }
  async deregisterCollection() {
    for (; this.collection.length > 0; )
      await this.deregister(this.collection[0]);
    return this.collection;
  }
  get(e, n = "id") {
    return this.collection.find((i) => i[n] === e);
  }
};
const g = {
  inert: ":not([inert]):not([inert] *)",
  negTabIndex: ':not([tabindex^="-"])',
  disabled: ":not(:disabled)"
}, zn = [
  `a[href]${g.inert}${g.negTabIndex}`,
  `area[href]${g.inert}${g.negTabIndex}`,
  `input:not([type="hidden"]):not([type="radio"])${g.inert}${g.negTabIndex}${g.disabled}`,
  `input[type="radio"]${g.inert}${g.negTabIndex}${g.disabled}`,
  `select${g.inert}${g.negTabIndex}${g.disabled}`,
  `textarea${g.inert}${g.negTabIndex}${g.disabled}`,
  `button${g.inert}${g.negTabIndex}${g.disabled}`,
  `details${g.inert} > summary:first-of-type${g.negTabIndex}`,
  // Discard until Firefox supports `:has()`
  // See: https://github.com/KittyGiraudel/focusable-selectors/issues/12
  // `details:not(:has(> summary))${not.inert}${not.negTabIndex}`,
  `iframe${g.inert}${g.negTabIndex}`,
  `audio[controls]${g.inert}${g.negTabIndex}`,
  `video[controls]${g.inert}${g.negTabIndex}`,
  `[contenteditable]${g.inert}${g.negTabIndex}`,
  `[tabindex]${g.inert}${g.negTabIndex}`
];
var $t, ct, dt;
let Kn = class {
  constructor(e = null, n = "[data-focus]") {
    Ht(this, $t, void 0), Ht(this, ct, void 0), Ht(this, dt, void 0), this.el = e, this.selectorFocus = n, it(this, ct, Gn.bind(this)), it(this, dt, Qn.bind(this));
  }
  get focusable() {
    return D(this, $t);
  }
  set focusable(e) {
    it(this, $t, e), D(this, $t).length ? (document.removeEventListener("keydown", D(this, dt)), document.addEventListener("keydown", D(this, ct))) : (document.removeEventListener("keydown", D(this, ct)), document.addEventListener("keydown", D(this, dt)));
  }
  get focusableFirst() {
    return this.focusable[0];
  }
  get focusableLast() {
    return this.focusable[this.focusable.length - 1];
  }
  mount(e, n) {
    e && (this.el = e), n && (this.selectorFocus = n), this.focusable = this.getFocusable(), this.focus();
  }
  unmount() {
    this.el = null, this.focusable = [], document.removeEventListener("keydown", D(this, ct)), document.removeEventListener("keydown", D(this, dt));
  }
  focus(e = this.el, n = this.selectorFocus) {
    (e.querySelector(n) || e).focus();
  }
  getFocusable(e = this.el) {
    const n = [], i = document.activeElement, s = e.scrollTop;
    return e.querySelectorAll(zn.join(",")).forEach((r) => {
      r.focus(), document.activeElement === r && n.push(r);
    }), e.scrollTop = s, i.focus(), n;
  }
};
$t = /* @__PURE__ */ new WeakMap(), ct = /* @__PURE__ */ new WeakMap(), dt = /* @__PURE__ */ new WeakMap();
function Gn(t) {
  (t.key === "Tab" || t.keyCode === 9) && (t.shiftKey ? (document.activeElement === this.focusableFirst || document.activeElement === this.el) && (t.preventDefault(), this.focusableLast.focus()) : (document.activeElement === this.focusableLast || document.activeElement === this.el) && (t.preventDefault(), this.focusableFirst.focus()));
}
function Qn(t) {
  (t.key === "Tab" || t.keyCode === 9) && t.preventDefault();
}
function Zn(t, e) {
  const n = (t.getAttribute(`data-${e}`) || "").replace(/'/g, '"');
  return n ? JSON.parse(n) : {};
}
function Un() {
  return getComputedStyle(document.body).getPropertyValue("--vrembem-variable-prefix").trim();
}
function Xn(t, e = !0) {
  const n = localStorage.getItem(t), i = n ? JSON.parse(n) : {};
  return {
    get(s) {
      return s ? i[s] : i;
    },
    set(s, r) {
      return r ? i[s] = r : delete i[s], e && localStorage.setItem(t, JSON.stringify(i)), i;
    }
  };
}
const Yn = (t, e) => new Promise((n) => {
  e.transition ? (t.classList.remove(e.stateClosed), t.classList.add(e.stateOpening), t.addEventListener("transitionend", function i(s) {
    s.target == t && (t.classList.add(e.stateOpened), t.classList.remove(e.stateOpening), n(t), this.removeEventListener("transitionend", i));
  })) : (t.classList.add(e.stateOpened), t.classList.remove(e.stateClosed), n(t));
}), ti = (t, e) => new Promise((n) => {
  e.transition ? (t.classList.add(e.stateClosing), t.classList.remove(e.stateOpened), t.addEventListener("transitionend", function i(s) {
    s.target == t && (t.classList.remove(e.stateClosing), t.classList.add(e.stateClosed), n(t), this.removeEventListener("transitionend", i));
  })) : (t.classList.add(e.stateClosed), t.classList.remove(e.stateOpened), n(t));
});
function ei(t, e) {
  e && document.querySelectorAll(e).forEach((n) => {
    t ? n.style.overflow = "hidden" : n.style.removeProperty("overflow");
  });
}
function ni(t, e) {
  e && document.querySelectorAll(e).forEach((n) => {
    t ? (n.inert = !0, n.setAttribute("aria-hidden", !0)) : (n.inert = null, n.removeAttribute("aria-hidden"));
  });
}
function le(t, e) {
  ni(!!t, e.selectorInert), ei(!!t, e.selectorOverflow);
}
const ii = {
  autoInit: !1,
  // Data attributes
  dataOpen: "drawer-open",
  dataClose: "drawer-close",
  dataToggle: "drawer-toggle",
  dataBreakpoint: "drawer-breakpoint",
  dataConfig: "drawer-config",
  // Selectors
  selectorDrawer: ".drawer",
  selectorDialog: ".drawer__dialog",
  selectorFocus: "[data-focus]",
  selectorInert: null,
  selectorOverflow: "body",
  // State classes
  stateOpened: "is-opened",
  stateOpening: "is-opening",
  stateClosing: "is-closing",
  stateClosed: "is-closed",
  // Classes
  classModal: "drawer_modal",
  // Feature toggles
  breakpoints: null,
  customEventPrefix: "drawer:",
  eventListeners: !0,
  store: !0,
  storeKey: "VB:DrawerState",
  setTabindex: !0,
  transition: !0
};
function si(t) {
  const e = t.target.closest(`
    [data-${this.settings.dataOpen}],
    [data-${this.settings.dataToggle}],
    [data-${this.settings.dataClose}]
  `);
  if (e) {
    t.preventDefault(), e.matches(`[data-${this.settings.dataToggle}]`) && e.getAttribute(`data-${this.settings.dataToggle}`).trim().split(" ").forEach((n) => {
      const i = this.get(n);
      i.trigger = e, i.toggle();
    }), e.matches(`[data-${this.settings.dataOpen}]`) && e.getAttribute(`data-${this.settings.dataOpen}`).trim().split(" ").forEach((n) => {
      const i = this.get(n);
      i.trigger = e, i.open();
    }), e.matches(`[data-${this.settings.dataClose}]`) && e.getAttribute(`data-${this.settings.dataClose}`).trim().split(" ").forEach((n) => {
      if (n) {
        const i = this.get(n);
        i.trigger = e, i.close();
      } else {
        const i = t.target.closest(this.settings.selectorDrawer);
        i && this.close(i);
      }
    });
    return;
  }
  t.target.matches(this.settings.selectorDrawer) && this.close(t.target.id);
}
function ri(t) {
  if (t.key === "Escape") {
    const e = this.activeModal;
    e && this.close(e);
  }
}
async function ne(t, e = !0) {
  if (!t)
    return this.collection;
  const n = this.collection.findIndex((i) => i.id === t.id);
  if (n >= 0) {
    const i = this.collection[n];
    e && i.state === "opened" && await i.close(!1), this.store.set(i.id), i.unmountBreakpoint(), Object.getOwnPropertyNames(i).forEach((s) => {
      delete i[s];
    }), this.collection.splice(n, 1);
  }
  return this.collection;
}
function oi(t) {
  const e = Un(), n = t.getAttribute(`data-${this.settings.dataBreakpoint}`);
  return this.settings.breakpoints && this.settings.breakpoints[n] ? this.settings.breakpoints[n] : getComputedStyle(document.body).getPropertyValue(`--${e}breakpoint-${n}`).trim() ? getComputedStyle(document.body).getPropertyValue(`--${e}breakpoint-${n}`).trim() : n;
}
function ce(t) {
  const e = typeof t == "string" ? this.get(t) : this.get(t.id);
  if (e)
    return e;
  throw new Error(`Drawer not found in collection with id of "${t.id || t}".`);
}
function Ze(t) {
  return typeof t == "string" ? t : typeof t.hasAttribute == "function" ? t.hasAttribute(`data-${this.settings.dataOpen}`) ? t.getAttribute(`data-${this.settings.dataOpen}`) : t.hasAttribute(`data-${this.settings.dataClose}`) ? t.getAttribute(`data-${this.settings.dataClose}`) || !1 : t.hasAttribute(`data-${this.settings.dataToggle}`) ? t.getAttribute(`data-${this.settings.dataToggle}`) : t.closest(this.settings.selectorDrawer) ? (t = t.closest(this.settings.selectorDrawer), t.id || !1) : !1 : t.id ? t.id : !1;
}
function ai(t) {
  const e = Ze.call(this, t);
  if (e) {
    const n = document.querySelector(`#${e}`), i = n ? n.querySelector(this.settings.selectorDialog) : null;
    return !n && !i ? { error: new Error(`No drawer elements found using the ID: "${e}".`) } : i ? { drawer: n, dialog: i } : { error: new Error("Drawer is missing dialog element.") };
  } else
    return { error: new Error("Could not resolve the drawer ID.") };
}
async function Ue(t) {
  this.store.get(t.id) ? this.store.get(t.id) === "opened" ? await t.open(!1, !1) : await t.close(!1, !1) : t.el.classList.contains(this.settings.stateOpened) ? t.state = "opened" : (t.el.classList.remove(this.settings.stateOpening), t.el.classList.remove(this.settings.stateClosing), t.el.classList.add(this.settings.stateClosed));
}
function Xe(t) {
  t.state === "opened" ? t.mode === "modal" ? this.focusTrap.mount(t.dialog, this.settings.selectorFocus) : this.focusTrap.focus(t.dialog, this.settings.selectorFocus) : (t.trigger && (t.trigger.focus(), t.trigger = null), this.focusTrap.unmount());
}
async function de(t, e, n = !0) {
  const i = ce.call(this, t), s = { ...this.settings, ...i.settings };
  return e !== void 0 && (s.transition = e), i.state === "closed" && (i.state = "opening", await Yn(i.el, s), i.mode === "modal" && le(!0, s), i.state = "opened"), n && Xe.call(this, i), i.el.dispatchEvent(new CustomEvent(s.customEventPrefix + "opened", {
    detail: this,
    bubbles: !0
  })), i;
}
async function Kt(t, e, n = !0) {
  const i = ce.call(this, t), s = { ...this.settings, ...i.settings };
  return e !== void 0 && (s.transition = e), i.state === "opened" && (i.state = "closing", document.activeElement.blur(), await ti(i.el, s), i.mode === "modal" && le(!1, s), n && Xe.call(this, i), i.state = "closed", i.el.dispatchEvent(new CustomEvent(s.customEventPrefix + "closed", {
    detail: this,
    bubbles: !0
  }))), i;
}
async function Ye(t, e, n) {
  const i = ce.call(this, t);
  return i.state === "closed" ? de.call(this, i, e, n) : Kt.call(this, i, e, n);
}
function li(t) {
  switch (t.mode) {
    case "inline":
      return ci.call(this, t);
    case "modal":
      return di.call(this, t);
    default:
      throw new Error(`"${t.mode}" is not a valid drawer mode.`);
  }
}
async function ci(t) {
  return t.el.classList.remove(t.getSetting("classModal")), t.dialog.removeAttribute("aria-modal"), le(!1, { ...this.settings, ...t.settings }), this.focusTrap.unmount(), await Ue.call(this, t), t.el.dispatchEvent(new CustomEvent(t.getSetting("customEventPrefix") + "switchMode", {
    detail: this,
    bubbles: !0
  })), t;
}
async function di(t) {
  return t.el.classList.add(t.getSetting("classModal")), t.dialog.setAttribute("aria-modal", "true"), !this.store.get(t.id) && t.el.classList.contains(t.getSetting("stateOpened")) && this.store.set(t.id, "opened"), await Kt.call(this, t, !1, !1), t.el.dispatchEvent(new CustomEvent(t.getSetting("customEventPrefix") + "switchMode", {
    detail: this,
    bubbles: !0
  })), t;
}
async function ui(t, e) {
  await ne.call(this, t, !1);
  const n = this, i = new Vn(), s = {
    open(o, c) {
      return de.call(n, this, o, c);
    },
    close(o, c) {
      return Kt.call(n, this, o, c);
    },
    toggle(o, c) {
      return Ye.call(n, this, o, c);
    },
    deregister() {
      return ne.call(n, this);
    },
    mountBreakpoint() {
      const o = this.breakpoint, c = this.handleBreakpoint.bind(this);
      return i.mount(o, c), this;
    },
    unmountBreakpoint() {
      return i.unmount(), this;
    },
    handleBreakpoint(o) {
      return this.mode = o.matches ? "inline" : "modal", this;
    },
    getSetting(o) {
      return o in this.settings ? this.settings[o] : n.settings[o];
    }
  }, r = {
    id: t.id,
    el: t,
    dialog: e,
    trigger: null,
    settings: Zn(t, this.settings.dataConfig),
    get breakpoint() {
      return oi.call(n, t);
    },
    get state() {
      return a;
    },
    set state(o) {
      a = o, (o === "opened" || o === "closed") && this.mode === "inline" && n.store.set(this.id, this.state);
    },
    get mode() {
      return l;
    },
    set mode(o) {
      l = o, li.call(n, this);
    },
    ...s
  };
  let a = t.classList.contains(r.getSetting("stateOpened")) ? "opened" : "closed", l = t.classList.contains(r.getSetting("classModal")) ? "modal" : "inline";
  return r.mode === "modal" ? r.dialog.setAttribute("aria-modal", "true") : r.dialog.removeAttribute("aria-modal"), r.getSetting("setTabindex") && r.dialog.setAttribute("tabindex", "-1"), this.collection.push(r), r.breakpoint ? r.mountBreakpoint() : await Ue.call(this, r), r;
}
var Et, xt;
let Xs = class extends Jn {
  constructor(e) {
    super(), De(this, Et, void 0), De(this, xt, void 0), this.defaults = ii, this.settings = { ...this.defaults, ...e }, this.focusTrap = new Kn(), this.store = Xn(this.settings.storeKey, this.settings.store), Pe(this, Et, si.bind(this)), Pe(this, xt, ri.bind(this)), this.settings.autoInit && this.init();
  }
  get activeModal() {
    return this.collection.find((e) => e.state === "opened" && e.mode === "modal");
  }
  async init(e = null) {
    e && (this.settings = { ...this.settings, ...e });
    const n = document.querySelectorAll(this.settings.selectorDrawer);
    return await this.registerCollection(n), this.settings.eventListeners && this.initEventListeners(), this;
  }
  async destroy() {
    return await this.deregisterCollection(), this.settings.eventListeners && this.destroyEventListeners(), this;
  }
  initEventListeners() {
    document.addEventListener("click", _t(this, Et), !1), document.addEventListener("keydown", _t(this, xt), !1);
  }
  destroyEventListeners() {
    document.removeEventListener("click", _t(this, Et), !1), document.removeEventListener("keydown", _t(this, xt), !1);
  }
  register(e) {
    const n = ai.call(this, e);
    return n.error ? Promise.reject(n.error) : ui.call(this, n.drawer, n.dialog);
  }
  deregister(e) {
    const n = this.get(Ze.call(this, e));
    return ne.call(this, n);
  }
  open(e, n, i) {
    return de.call(this, e, n, i);
  }
  close(e, n, i) {
    return Kt.call(this, e, n, i);
  }
  toggle(e, n, i) {
    return Ye.call(this, e, n, i);
  }
};
Et = /* @__PURE__ */ new WeakMap(), xt = /* @__PURE__ */ new WeakMap();
var tn = (t, e, n) => {
  if (!e.has(t))
    throw TypeError("Cannot " + n);
}, Ft = (t, e, n) => (tn(t, e, "read from private field"), n ? n.call(t) : e.get(t)), qe = (t, e, n) => {
  if (e.has(t))
    throw TypeError("Cannot add the same private member more than once");
  e instanceof WeakSet ? e.add(t) : e.set(t, n);
}, Me = (t, e, n, i) => (tn(t, e, "write to private field"), i ? i.call(t, n) : e.set(t, n), n), en = (t, e, n) => {
  if (!e.has(t))
    throw TypeError("Cannot " + n);
}, Q = (t, e, n) => (en(t, e, "read from private field"), n ? n.call(t) : e.get(t)), Yt = (t, e, n) => {
  if (e.has(t))
    throw TypeError("Cannot add the same private member more than once");
  e instanceof WeakSet ? e.add(t) : e.set(t, n);
}, te = (t, e, n, i) => (en(t, e, "write to private field"), i ? i.call(t, n) : e.set(t, n), n);
class hi {
  constructor() {
    this.collection = [];
  }
  async register(e) {
    return await this.deregister(e), this.collection.push(e), this.collection;
  }
  async deregister(e) {
    const n = this.collection.findIndex((i) => i === e);
    if (n >= 0) {
      const i = this.collection[n];
      Object.getOwnPropertyNames(i).forEach((s) => {
        delete i[s];
      }), this.collection.splice(n, 1);
    }
    return this.collection;
  }
  async registerCollection(e) {
    return await Promise.all(Array.from(e, (n) => {
      this.register(n);
    })), this.collection;
  }
  async deregisterCollection() {
    for (; this.collection.length > 0; )
      await this.deregister(this.collection[0]);
    return this.collection;
  }
  get(e, n = "id") {
    return this.collection.find((i) => i[n] === e);
  }
}
const m = {
  inert: ":not([inert]):not([inert] *)",
  negTabIndex: ':not([tabindex^="-"])',
  disabled: ":not(:disabled)"
}, fi = [
  `a[href]${m.inert}${m.negTabIndex}`,
  `area[href]${m.inert}${m.negTabIndex}`,
  `input:not([type="hidden"]):not([type="radio"])${m.inert}${m.negTabIndex}${m.disabled}`,
  `input[type="radio"]${m.inert}${m.negTabIndex}${m.disabled}`,
  `select${m.inert}${m.negTabIndex}${m.disabled}`,
  `textarea${m.inert}${m.negTabIndex}${m.disabled}`,
  `button${m.inert}${m.negTabIndex}${m.disabled}`,
  `details${m.inert} > summary:first-of-type${m.negTabIndex}`,
  // Discard until Firefox supports `:has()`
  // See: https://github.com/KittyGiraudel/focusable-selectors/issues/12
  // `details:not(:has(> summary))${not.inert}${not.negTabIndex}`,
  `iframe${m.inert}${m.negTabIndex}`,
  `audio[controls]${m.inert}${m.negTabIndex}`,
  `video[controls]${m.inert}${m.negTabIndex}`,
  `[contenteditable]${m.inert}${m.negTabIndex}`,
  `[tabindex]${m.inert}${m.negTabIndex}`
];
var Lt, ut, ht;
let pi = class {
  constructor(e = null, n = "[data-focus]") {
    Yt(this, Lt, void 0), Yt(this, ut, void 0), Yt(this, ht, void 0), this.el = e, this.selectorFocus = n, te(this, ut, gi.bind(this)), te(this, ht, mi.bind(this));
  }
  get focusable() {
    return Q(this, Lt);
  }
  set focusable(e) {
    te(this, Lt, e), Q(this, Lt).length ? (document.removeEventListener("keydown", Q(this, ht)), document.addEventListener("keydown", Q(this, ut))) : (document.removeEventListener("keydown", Q(this, ut)), document.addEventListener("keydown", Q(this, ht)));
  }
  get focusableFirst() {
    return this.focusable[0];
  }
  get focusableLast() {
    return this.focusable[this.focusable.length - 1];
  }
  mount(e, n) {
    e && (this.el = e), n && (this.selectorFocus = n), this.focusable = this.getFocusable(), this.focus();
  }
  unmount() {
    this.el = null, this.focusable = [], document.removeEventListener("keydown", Q(this, ut)), document.removeEventListener("keydown", Q(this, ht));
  }
  focus(e = this.el, n = this.selectorFocus) {
    (e.querySelector(n) || e).focus();
  }
  getFocusable(e = this.el) {
    const n = [], i = document.activeElement, s = e.scrollTop;
    return e.querySelectorAll(fi.join(",")).forEach((r) => {
      r.focus(), document.activeElement === r && n.push(r);
    }), e.scrollTop = s, i.focus(), n;
  }
};
Lt = /* @__PURE__ */ new WeakMap(), ut = /* @__PURE__ */ new WeakMap(), ht = /* @__PURE__ */ new WeakMap();
function gi(t) {
  (t.key === "Tab" || t.keyCode === 9) && (t.shiftKey ? (document.activeElement === this.focusableFirst || document.activeElement === this.el) && (t.preventDefault(), this.focusableLast.focus()) : (document.activeElement === this.focusableLast || document.activeElement === this.el) && (t.preventDefault(), this.focusableFirst.focus()));
}
function mi(t) {
  (t.key === "Tab" || t.keyCode === 9) && t.preventDefault();
}
function vi(t, e) {
  const n = (t.getAttribute(`data-${e}`) || "").replace(/'/g, '"');
  return n ? JSON.parse(n) : {};
}
function We(t, e, n) {
  const i = e.nodeType === Node.COMMENT_NODE, s = e.nodeType === Node.ELEMENT_NODE;
  if (e = i || s ? e : document.querySelector(e), i && (n = "after"), !e)
    throw new Error(`Not a valid teleport reference: '${e}'`);
  if (typeof e[n] != "function")
    throw new Error(`Not a valid teleport method: '${n}'`);
  let r = null;
  return i || (r = document.createComment("teleported #" + t.id), t.before(r)), e[n](t), i && e.remove(), r;
}
const bi = (t, e) => new Promise((n) => {
  e.transition ? (t.classList.remove(e.stateClosed), t.classList.add(e.stateOpening), t.addEventListener("transitionend", function i(s) {
    s.target == t && (t.classList.add(e.stateOpened), t.classList.remove(e.stateOpening), n(t), this.removeEventListener("transitionend", i));
  })) : (t.classList.add(e.stateOpened), t.classList.remove(e.stateClosed), n(t));
}), yi = (t, e) => new Promise((n) => {
  e.transition ? (t.classList.add(e.stateClosing), t.classList.remove(e.stateOpened), t.addEventListener("transitionend", function i(s) {
    s.target == t && (t.classList.remove(e.stateClosing), t.classList.add(e.stateClosed), n(t), this.removeEventListener("transitionend", i));
  })) : (t.classList.add(e.stateClosed), t.classList.remove(e.stateOpened), n(t));
});
function wi(t, e) {
  e && document.querySelectorAll(e).forEach((n) => {
    t ? n.style.overflow = "hidden" : n.style.removeProperty("overflow");
  });
}
function $i(t, e) {
  e && document.querySelectorAll(e).forEach((n) => {
    t ? (n.inert = !0, n.setAttribute("aria-hidden", !0)) : (n.inert = null, n.removeAttribute("aria-hidden"));
  });
}
function Ei(t, e) {
  $i(!!t, e.selectorInert), wi(!!t, e.selectorOverflow);
}
const xi = {
  autoInit: !1,
  // Data attributes
  dataOpen: "modal-open",
  dataClose: "modal-close",
  dataReplace: "modal-replace",
  dataConfig: "modal-config",
  // Selectors
  selectorModal: ".modal",
  selectorDialog: ".modal__dialog",
  selectorRequired: '[role="alertdialog"]',
  selectorFocus: "[data-focus]",
  selectorInert: null,
  selectorOverflow: "body",
  // State classes
  stateOpened: "is-opened",
  stateOpening: "is-opening",
  stateClosing: "is-closing",
  stateClosed: "is-closed",
  // Feature settings
  customEventPrefix: "modal:",
  eventListeners: !0,
  teleport: null,
  teleportMethod: "append",
  setTabindex: !0,
  transition: !0
};
function ue(t) {
  const e = typeof t == "string" ? this.get(t) : this.get(t.id);
  if (e)
    return e;
  throw new Error(`Modal not found in collection with id of "${t.id || t}".`);
}
function Jt(t) {
  return typeof t == "string" ? t : typeof t.hasAttribute == "function" ? t.hasAttribute(`data-${this.settings.dataOpen}`) ? t.getAttribute(`data-${this.settings.dataOpen}`) : t.hasAttribute(`data-${this.settings.dataClose}`) ? t.getAttribute(`data-${this.settings.dataClose}`) || !1 : t.hasAttribute(`data-${this.settings.dataReplace}`) ? t.getAttribute(`data-${this.settings.dataReplace}`) : t.closest(this.settings.selectorModal) ? (t = t.closest(this.settings.selectorModal), t.id || !1) : !1 : t.id ? t.id : !1;
}
function Li(t) {
  const e = Jt.call(this, t);
  if (e) {
    const n = document.querySelector(`#${e}`), i = n ? n.querySelector(this.settings.selectorDialog) : null;
    return !n && !i ? { error: new Error(`No modal elements found using the ID: "${e}".`) } : i ? { modal: n, dialog: i } : { error: new Error("Modal is missing dialog element.") };
  } else
    return { error: new Error("Could not resolve the modal ID.") };
}
function Gt() {
  this.active ? this.focusTrap.mount(this.active.dialog, this.settings.selectorFocus) : (this.trigger && (this.trigger.focus(), this.trigger = null), this.focusTrap.unmount());
}
async function Oi(t) {
  let e = t.target.closest(
    `[data-${this.settings.dataOpen}], [data-${this.settings.dataReplace}]`
  );
  if (e) {
    t.preventDefault(), t.target.closest(this.settings.selectorModal) || (this.trigger = e);
    const n = this.get(Jt.call(this, e));
    return e.matches(`[data-${this.settings.dataOpen}]`) ? n.open() : n.replace();
  }
  if (e = t.target.closest(`[data-${this.settings.dataClose}]`), e) {
    t.preventDefault();
    const n = e.getAttribute(`data-${this.settings.dataClose}`);
    return n === "*" ? this.closeAll() : this.close(n);
  }
  if (t.target.matches(this.settings.selectorModal) && !t.target.querySelector(this.settings.selectorRequired))
    return this.close(Jt.call(this, t.target));
}
function ki(t) {
  if (t.key === "Escape" && this.active && !this.active.dialog.matches(this.settings.selectorRequired))
    return this.close();
}
async function ie(t, e = !0) {
  if (!t)
    return this.collection;
  const n = this.collection.findIndex((i) => i.id === t.id);
  if (n >= 0) {
    const i = this.collection[n];
    e && i.state === "opened" ? await i.close(!1) : this.stack.remove(i), i.getSetting("teleport") && i.teleportReturn(), Object.getOwnPropertyNames(i).forEach((s) => {
      delete i[s];
    }), this.collection.splice(n, 1);
  }
  return this.collection;
}
async function he(t, e, n = !0) {
  const i = ue.call(this, t), s = { ...this.settings, ...i.settings };
  return e !== void 0 && (s.transition = e), this.stack.moveToTop(i), i.state === "closed" && (i.state = "opening", this.stack.add(i), await bi(i.el, s), i.state = "opened"), n && Gt.call(this), i.el.dispatchEvent(new CustomEvent(s.customEventPrefix + "opened", {
    detail: this,
    bubbles: !0
  })), i;
}
async function fe(t, e, n = !0) {
  const i = t ? ue.call(this, t) : this.active;
  if (i && i.state === "opened") {
    i.state = "closing";
    const s = { ...this.settings, ...i.settings };
    e !== void 0 && (s.transition = e), document.activeElement.blur(), await yi(i.el, s), this.stack.remove(i), n && Gt.call(this), i.state = "closed", i.el.dispatchEvent(new CustomEvent(s.customEventPrefix + "closed", {
      detail: this,
      bubbles: !0
    }));
  }
  return i;
}
async function se(t, e) {
  const n = [];
  return await Promise.all(this.stack.value.map(async (i) => {
    t && t === i.id ? Promise.resolve() : n.push(await fe.call(this, i, e, !1)), i.trigger = null;
  })), n;
}
async function nn(t, e, n = !0) {
  const i = ue.call(this, t);
  let s, r;
  return i.state === "opened" ? (s = i, r = await se.call(this, i.id, e)) : (s = he.call(this, i, e, !1), r = se.call(this, !1, e), await Promise.all([s, r])), n && Gt.call(this), { opened: s, closed: r };
}
async function Ti(t, e) {
  await ie.call(this, t, !1);
  const n = this, i = {
    open(r, a) {
      return he.call(n, this, r, a);
    },
    close(r, a) {
      return fe.call(n, this, r, a);
    },
    replace(r, a) {
      return nn.call(n, this, r, a);
    },
    deregister() {
      return ie.call(n, this);
    },
    teleport(r = this.getSetting("teleport"), a = this.getSetting("teleportMethod")) {
      return this.returnRef ? (console.error("Element has already been teleported:", this.el), !1) : (this.returnRef = We(this.el, r, a), this.el);
    },
    teleportReturn() {
      return this.returnRef ? (this.returnRef = We(this.el, this.returnRef), this.el) : (console.error("No return reference found:", this.el), !1);
    },
    getSetting(r) {
      return r in this.settings ? this.settings[r] : n.settings[r];
    }
  }, s = {
    id: t.id,
    state: "closed",
    el: t,
    dialog: e,
    returnRef: null,
    settings: vi(t, this.settings.dataConfig),
    ...i
  };
  return s.dialog.setAttribute("aria-modal", "true"), s.dialog.hasAttribute("role") || s.dialog.setAttribute("role", "dialog"), s.getSetting("setTabindex") && s.dialog.setAttribute("tabindex", "-1"), s.getSetting("teleport") && s.teleport(), this.collection.push(s), s.el.classList.contains(this.settings.stateOpened) ? await s.open(!1) : (s.el.classList.remove(this.settings.stateOpening), s.el.classList.remove(this.settings.stateClosing), s.el.classList.add(this.settings.stateClosed)), s;
}
function Ai(t) {
  const e = [];
  return {
    get value() {
      return [...e];
    },
    get top() {
      return e[e.length - 1];
    },
    updateIndex() {
      e.forEach((n, i) => {
        n.el.style.zIndex = null;
        const s = getComputedStyle(n.el)["z-index"];
        n.el.style.zIndex = parseInt(s) + i + 1;
      });
    },
    updateGlobalState() {
      Ei(this.top, t), this.updateIndex();
    },
    add(n) {
      n.el.style.zIndex = null;
      const i = getComputedStyle(n.el)["z-index"];
      n.el.style.zIndex = parseInt(i) + e.length + 1, e.push(n), this.updateGlobalState();
    },
    remove(n) {
      const i = e.findIndex((s) => s.id === n.id);
      i >= 0 && (n.el.style.zIndex = null, e.splice(i, 1), this.updateGlobalState());
    },
    moveToTop(n) {
      const i = e.findIndex((s) => s.id === n.id);
      i >= 0 && (e.splice(i, 1), this.add(n));
    }
  };
}
var Ot, kt;
class er extends hi {
  constructor(e) {
    super(), qe(this, Ot, void 0), qe(this, kt, void 0), this.defaults = xi, this.settings = { ...this.defaults, ...e }, this.trigger = null, this.focusTrap = new pi(), this.stack = Ai(this.settings), Me(this, Ot, Oi.bind(this)), Me(this, kt, ki.bind(this)), this.settings.autoInit && this.init();
  }
  get active() {
    return this.stack.top;
  }
  async init(e) {
    e && (this.settings = { ...this.settings, ...e });
    const n = document.querySelectorAll(this.settings.selectorModal);
    return await this.registerCollection(n), this.settings.eventListeners && this.initEventListeners(), this;
  }
  async destroy() {
    return this.trigger = null, await this.deregisterCollection(), this.settings.eventListeners && this.destroyEventListeners(), this;
  }
  initEventListeners() {
    document.addEventListener("click", Ft(this, Ot), !1), document.addEventListener("keydown", Ft(this, kt), !1);
  }
  destroyEventListeners() {
    document.removeEventListener("click", Ft(this, Ot), !1), document.removeEventListener("keydown", Ft(this, kt), !1);
  }
  register(e) {
    const n = Li.call(this, e);
    return n.error ? Promise.reject(n.error) : Ti.call(this, n.modal, n.dialog);
  }
  deregister(e) {
    const n = this.get(Jt.call(this, e));
    return ie.call(this, n);
  }
  open(e, n, i) {
    return he.call(this, e, n, i);
  }
  close(e, n, i) {
    return fe.call(this, e, n, i);
  }
  replace(e, n, i) {
    return nn.call(this, e, n, i);
  }
  async closeAll(e = !1, n, i = !0) {
    const s = await se.call(this, e, n);
    return i && Gt.call(this), s;
  }
}
Ot = /* @__PURE__ */ new WeakMap(), kt = /* @__PURE__ */ new WeakMap();
var sn = (t, e, n) => {
  if (!e.has(t))
    throw TypeError("Cannot " + n);
}, je = (t, e, n) => (sn(t, e, "read from private field"), n ? n.call(t) : e.get(t)), Ci = (t, e, n) => {
  if (e.has(t))
    throw TypeError("Cannot add the same private member more than once");
  e instanceof WeakSet ? e.add(t) : e.set(t, n);
}, Ii = (t, e, n, i) => (sn(t, e, "write to private field"), i ? i.call(t, n) : e.set(t, n), n);
class Si {
  constructor() {
    this.collection = [];
  }
  async register(e) {
    return await this.deregister(e), this.collection.push(e), this.collection;
  }
  async deregister(e) {
    const n = this.collection.findIndex((i) => i === e);
    if (n >= 0) {
      const i = this.collection[n];
      Object.getOwnPropertyNames(i).forEach((s) => {
        delete i[s];
      }), this.collection.splice(n, 1);
    }
    return this.collection;
  }
  async registerCollection(e) {
    return await Promise.all(Array.from(e, (n) => {
      this.register(n);
    })), this.collection;
  }
  async deregisterCollection() {
    for (; this.collection.length > 0; )
      await this.deregister(this.collection[0]);
    return this.collection;
  }
  get(e, n = "id") {
    return this.collection.find((i) => i[n] === e);
  }
}
function Di() {
  return getComputedStyle(document.body).getPropertyValue("--vrembem-variable-prefix").trim();
}
const Pi = {
  autoInit: !1,
  // Selectors
  selectorPopover: ".popover",
  selectorArrow: ".popover__arrow",
  // State classes
  stateActive: "is-active",
  // Feature settings
  eventListeners: !0,
  eventType: "click",
  placement: "bottom"
};
function rn(t, e) {
  const n = getComputedStyle(t), i = {
    placement: e.placement,
    event: e.eventType,
    offset: 0,
    "overflow-padding": 0,
    "flip-padding": 0,
    "arrow-element": e.selectorArrow,
    "arrow-padding": 0
  };
  for (const s in i) {
    const r = Di(), a = n.getPropertyValue(`--${r}popover-${s}`).trim();
    a && (i[s] = a);
  }
  return i;
}
function ee(t) {
  let e;
  const n = typeof t == "string" ? t.trim().split(" ") : [t];
  switch (n.forEach(function(i, s) {
    n[s] = parseInt(i, 10);
  }), n.length) {
    case 1:
      e = n[0];
      break;
    case 2:
      e = {
        top: n[0],
        right: n[1],
        bottom: n[0],
        left: n[1]
      };
      break;
    case 3:
      e = {
        top: n[0],
        right: n[1],
        bottom: n[2],
        left: n[1]
      };
      break;
    case 4:
      e = {
        top: n[0],
        right: n[1],
        bottom: n[2],
        left: n[3]
      };
      break;
    default:
      e = !1;
      break;
  }
  return e;
}
function qi(t) {
  return [{
    name: "offset",
    options: {
      offset: [0, parseInt(t.offset, 10)]
    }
  }, {
    name: "preventOverflow",
    options: {
      padding: ee(t["overflow-padding"])
    }
  }, {
    name: "flip",
    options: {
      padding: ee(t["flip-padding"])
    }
  }, {
    name: "arrow",
    options: {
      element: t["arrow-element"],
      padding: ee(t["arrow-padding"])
    }
  }];
}
function on(t) {
  const e = typeof t == "string" ? this.get(t) : this.get(t.id);
  if (e)
    return e;
  throw new Error(`Popover not found in collection with id of "${t}".`);
}
function an(t) {
  return typeof t == "string" ? t : typeof t.hasAttribute == "function" ? t.closest(this.settings.selectorPopover) ? (t = t.closest(this.settings.selectorPopover), t.id) : t.hasAttribute("aria-controls") ? t.getAttribute("aria-controls") : t.hasAttribute("aria-describedby") ? t.getAttribute("aria-describedby") : !1 : t.id ? t.id : !1;
}
function Mi(t) {
  const e = an.call(this, t);
  if (e) {
    const n = document.querySelector(`#${e}`), i = document.querySelector(`[aria-controls="${e}"]`) || document.querySelector(`[aria-describedby="${e}"]`);
    return !i && !n ? { error: new Error(`No popover elements found using the ID: "${e}".`) } : i ? n ? { popover: n, trigger: i } : { error: new Error("No popover associated with the provided popover trigger.") } : { error: new Error("No popover trigger associated with the provided popover.") };
  } else
    return { error: new Error("Could not resolve the popover ID.") };
}
async function pe(t) {
  const e = t ? on.call(this, t) : await ln.call(this);
  return e && e.state === "opened" && (e.el.classList.remove(this.settings.stateActive), e.trigger.hasAttribute("aria-controls") && e.trigger.setAttribute("aria-expanded", "false"), e.popper.setOptions({
    modifiers: [{ name: "eventListeners", enabled: !1 }]
  }), e.state = "closed", e.trigger === this.trigger && (this.trigger = null)), e;
}
async function ln() {
  const t = [];
  return await Promise.all(this.collection.map(async (e) => {
    e.state === "opened" && t.push(await pe.call(this, e));
  })), t;
}
function cn(t) {
  t.state == "opened" && setTimeout(() => {
    const e = t.el.closest(":hover") === t.el || t.trigger.closest(":hover") === t.trigger, n = document.activeElement.closest(
      `#${t.id}, [aria-controls="${t.id}"], [aria-describedby="${t.id}"]`
    );
    return !e && !n && t.close(), t;
  }, 1);
}
function Wi(t) {
  t.state === "opened" ? t.close() : (this.trigger = t.trigger, t.open(), dn.call(this, t));
}
function ji(t) {
  switch (t.key) {
    case "Escape":
      this.trigger && this.trigger.focus(), ln.call(this);
      return;
    case "Tab":
      this.collection.forEach((e) => {
        cn.call(this, e);
      });
      return;
    default:
      return;
  }
}
function dn(t) {
  const e = this;
  document.addEventListener("click", function n(i) {
    i.target.closest(
      `#${t.id}, [aria-controls="${t.id}"], [aria-describedby="${t.id}"]`
    ) ? t.el && !t.el.classList.contains(e.settings.stateActive) && this.removeEventListener("click", n) : (t.el && t.el.classList.contains(e.settings.stateActive) && t.close(), this.removeEventListener("click", n));
  });
}
var W = "top", B = "bottom", R = "right", j = "left", ge = "auto", Dt = [W, B, R, j], ft = "start", It = "end", Ni = "clippingParents", un = "viewport", yt = "popper", _i = "reference", Ne = /* @__PURE__ */ Dt.reduce(function(t, e) {
  return t.concat([e + "-" + ft, e + "-" + It]);
}, []), hn = /* @__PURE__ */ [].concat(Dt, [ge]).reduce(function(t, e) {
  return t.concat([e, e + "-" + ft, e + "-" + It]);
}, []), Fi = "beforeRead", Bi = "read", Ri = "afterRead", Hi = "beforeMain", Vi = "main", Ji = "afterMain", zi = "beforeWrite", Ki = "write", Gi = "afterWrite", Qi = [Fi, Bi, Ri, Hi, Vi, Ji, zi, Ki, Gi];
function z(t) {
  return t ? (t.nodeName || "").toLowerCase() : null;
}
function _(t) {
  if (t == null)
    return window;
  if (t.toString() !== "[object Window]") {
    var e = t.ownerDocument;
    return e && e.defaultView || window;
  }
  return t;
}
function rt(t) {
  var e = _(t).Element;
  return t instanceof e || t instanceof Element;
}
function F(t) {
  var e = _(t).HTMLElement;
  return t instanceof e || t instanceof HTMLElement;
}
function me(t) {
  if (typeof ShadowRoot > "u")
    return !1;
  var e = _(t).ShadowRoot;
  return t instanceof e || t instanceof ShadowRoot;
}
function Zi(t) {
  var e = t.state;
  Object.keys(e.elements).forEach(function(n) {
    var i = e.styles[n] || {}, s = e.attributes[n] || {}, r = e.elements[n];
    !F(r) || !z(r) || (Object.assign(r.style, i), Object.keys(s).forEach(function(a) {
      var l = s[a];
      l === !1 ? r.removeAttribute(a) : r.setAttribute(a, l === !0 ? "" : l);
    }));
  });
}
function Ui(t) {
  var e = t.state, n = {
    popper: {
      position: e.options.strategy,
      left: "0",
      top: "0",
      margin: "0"
    },
    arrow: {
      position: "absolute"
    },
    reference: {}
  };
  return Object.assign(e.elements.popper.style, n.popper), e.styles = n, e.elements.arrow && Object.assign(e.elements.arrow.style, n.arrow), function() {
    Object.keys(e.elements).forEach(function(i) {
      var s = e.elements[i], r = e.attributes[i] || {}, a = Object.keys(e.styles.hasOwnProperty(i) ? e.styles[i] : n[i]), l = a.reduce(function(o, c) {
        return o[c] = "", o;
      }, {});
      !F(s) || !z(s) || (Object.assign(s.style, l), Object.keys(r).forEach(function(o) {
        s.removeAttribute(o);
      }));
    });
  };
}
const Xi = {
  name: "applyStyles",
  enabled: !0,
  phase: "write",
  fn: Zi,
  effect: Ui,
  requires: ["computeStyles"]
};
function J(t) {
  return t.split("-")[0];
}
var st = Math.max, zt = Math.min, pt = Math.round;
function re() {
  var t = navigator.userAgentData;
  return t != null && t.brands && Array.isArray(t.brands) ? t.brands.map(function(e) {
    return e.brand + "/" + e.version;
  }).join(" ") : navigator.userAgent;
}
function fn() {
  return !/^((?!chrome|android).)*safari/i.test(re());
}
function gt(t, e, n) {
  e === void 0 && (e = !1), n === void 0 && (n = !1);
  var i = t.getBoundingClientRect(), s = 1, r = 1;
  e && F(t) && (s = t.offsetWidth > 0 && pt(i.width) / t.offsetWidth || 1, r = t.offsetHeight > 0 && pt(i.height) / t.offsetHeight || 1);
  var a = rt(t) ? _(t) : window, l = a.visualViewport, o = !fn() && n, c = (i.left + (o && l ? l.offsetLeft : 0)) / s, d = (i.top + (o && l ? l.offsetTop : 0)) / r, b = i.width / s, v = i.height / r;
  return {
    width: b,
    height: v,
    top: d,
    right: c + b,
    bottom: d + v,
    left: c,
    x: c,
    y: d
  };
}
function ve(t) {
  var e = gt(t), n = t.offsetWidth, i = t.offsetHeight;
  return Math.abs(e.width - n) <= 1 && (n = e.width), Math.abs(e.height - i) <= 1 && (i = e.height), {
    x: t.offsetLeft,
    y: t.offsetTop,
    width: n,
    height: i
  };
}
function pn(t, e) {
  var n = e.getRootNode && e.getRootNode();
  if (t.contains(e))
    return !0;
  if (n && me(n)) {
    var i = e;
    do {
      if (i && t.isSameNode(i))
        return !0;
      i = i.parentNode || i.host;
    } while (i);
  }
  return !1;
}
function G(t) {
  return _(t).getComputedStyle(t);
}
function Yi(t) {
  return ["table", "td", "th"].indexOf(z(t)) >= 0;
}
function Z(t) {
  return ((rt(t) ? t.ownerDocument : (
    // $FlowFixMe[prop-missing]
    t.document
  )) || window.document).documentElement;
}
function Qt(t) {
  return z(t) === "html" ? t : (
    // this is a quicker (but less type safe) way to save quite some bytes from the bundle
    // $FlowFixMe[incompatible-return]
    // $FlowFixMe[prop-missing]
    t.assignedSlot || // step into the shadow DOM of the parent of a slotted node
    t.parentNode || // DOM Element detected
    (me(t) ? t.host : null) || // ShadowRoot detected
    // $FlowFixMe[incompatible-call]: HTMLElement is a Node
    Z(t)
  );
}
function _e(t) {
  return !F(t) || // https://github.com/popperjs/popper-core/issues/837
  G(t).position === "fixed" ? null : t.offsetParent;
}
function ts(t) {
  var e = /firefox/i.test(re()), n = /Trident/i.test(re());
  if (n && F(t)) {
    var i = G(t);
    if (i.position === "fixed")
      return null;
  }
  var s = Qt(t);
  for (me(s) && (s = s.host); F(s) && ["html", "body"].indexOf(z(s)) < 0; ) {
    var r = G(s);
    if (r.transform !== "none" || r.perspective !== "none" || r.contain === "paint" || ["transform", "perspective"].indexOf(r.willChange) !== -1 || e && r.willChange === "filter" || e && r.filter && r.filter !== "none")
      return s;
    s = s.parentNode;
  }
  return null;
}
function Pt(t) {
  for (var e = _(t), n = _e(t); n && Yi(n) && G(n).position === "static"; )
    n = _e(n);
  return n && (z(n) === "html" || z(n) === "body" && G(n).position === "static") ? e : n || ts(t) || e;
}
function be(t) {
  return ["top", "bottom"].indexOf(t) >= 0 ? "x" : "y";
}
function At(t, e, n) {
  return st(t, zt(e, n));
}
function es(t, e, n) {
  var i = At(t, e, n);
  return i > n ? n : i;
}
function gn() {
  return {
    top: 0,
    right: 0,
    bottom: 0,
    left: 0
  };
}
function mn(t) {
  return Object.assign({}, gn(), t);
}
function vn(t, e) {
  return e.reduce(function(n, i) {
    return n[i] = t, n;
  }, {});
}
var ns = function(t, e) {
  return t = typeof t == "function" ? t(Object.assign({}, e.rects, {
    placement: e.placement
  })) : t, mn(typeof t != "number" ? t : vn(t, Dt));
};
function is(t) {
  var e, n = t.state, i = t.name, s = t.options, r = n.elements.arrow, a = n.modifiersData.popperOffsets, l = J(n.placement), o = be(l), c = [j, R].indexOf(l) >= 0, d = c ? "height" : "width";
  if (!(!r || !a)) {
    var b = ns(s.padding, n), v = ve(r), h = o === "y" ? W : j, $ = o === "y" ? B : R, u = n.rects.reference[d] + n.rects.reference[o] - a[o] - n.rects.popper[d], w = a[o] - n.rects.reference[o], E = Pt(r), L = E ? o === "y" ? E.clientHeight || 0 : E.clientWidth || 0 : 0, O = u / 2 - w / 2, f = b[h], y = L - v[d] - b[$], x = L / 2 - v[d] / 2 + O, k = At(f, x, y), T = o;
    n.modifiersData[i] = (e = {}, e[T] = k, e.centerOffset = k - x, e);
  }
}
function ss(t) {
  var e = t.state, n = t.options, i = n.element, s = i === void 0 ? "[data-popper-arrow]" : i;
  s != null && (typeof s == "string" && (s = e.elements.popper.querySelector(s), !s) || pn(e.elements.popper, s) && (e.elements.arrow = s));
}
const rs = {
  name: "arrow",
  enabled: !0,
  phase: "main",
  fn: is,
  effect: ss,
  requires: ["popperOffsets"],
  requiresIfExists: ["preventOverflow"]
};
function mt(t) {
  return t.split("-")[1];
}
var os = {
  top: "auto",
  right: "auto",
  bottom: "auto",
  left: "auto"
};
function as(t, e) {
  var n = t.x, i = t.y, s = e.devicePixelRatio || 1;
  return {
    x: pt(n * s) / s || 0,
    y: pt(i * s) / s || 0
  };
}
function Fe(t) {
  var e, n = t.popper, i = t.popperRect, s = t.placement, r = t.variation, a = t.offsets, l = t.position, o = t.gpuAcceleration, c = t.adaptive, d = t.roundOffsets, b = t.isFixed, v = a.x, h = v === void 0 ? 0 : v, $ = a.y, u = $ === void 0 ? 0 : $, w = typeof d == "function" ? d({
    x: h,
    y: u
  }) : {
    x: h,
    y: u
  };
  h = w.x, u = w.y;
  var E = a.hasOwnProperty("x"), L = a.hasOwnProperty("y"), O = j, f = W, y = window;
  if (c) {
    var x = Pt(n), k = "clientHeight", T = "clientWidth";
    if (x === _(n) && (x = Z(n), G(x).position !== "static" && l === "absolute" && (k = "scrollHeight", T = "scrollWidth")), x = x, s === W || (s === j || s === R) && r === It) {
      f = B;
      var A = b && x === y && y.visualViewport ? y.visualViewport.height : (
        // $FlowFixMe[prop-missing]
        x[k]
      );
      u -= A - i.height, u *= o ? 1 : -1;
    }
    if (s === j || (s === W || s === B) && r === It) {
      O = R;
      var C = b && x === y && y.visualViewport ? y.visualViewport.width : (
        // $FlowFixMe[prop-missing]
        x[T]
      );
      h -= C - i.width, h *= o ? 1 : -1;
    }
  }
  var I = Object.assign({
    position: l
  }, c && os), H = d === !0 ? as({
    x: h,
    y: u
  }, _(n)) : {
    x: h,
    y: u
  };
  if (h = H.x, u = H.y, o) {
    var P;
    return Object.assign({}, I, (P = {}, P[f] = L ? "0" : "", P[O] = E ? "0" : "", P.transform = (y.devicePixelRatio || 1) <= 1 ? "translate(" + h + "px, " + u + "px)" : "translate3d(" + h + "px, " + u + "px, 0)", P));
  }
  return Object.assign({}, I, (e = {}, e[f] = L ? u + "px" : "", e[O] = E ? h + "px" : "", e.transform = "", e));
}
function ls(t) {
  var e = t.state, n = t.options, i = n.gpuAcceleration, s = i === void 0 ? !0 : i, r = n.adaptive, a = r === void 0 ? !0 : r, l = n.roundOffsets, o = l === void 0 ? !0 : l, c = {
    placement: J(e.placement),
    variation: mt(e.placement),
    popper: e.elements.popper,
    popperRect: e.rects.popper,
    gpuAcceleration: s,
    isFixed: e.options.strategy === "fixed"
  };
  e.modifiersData.popperOffsets != null && (e.styles.popper = Object.assign({}, e.styles.popper, Fe(Object.assign({}, c, {
    offsets: e.modifiersData.popperOffsets,
    position: e.options.strategy,
    adaptive: a,
    roundOffsets: o
  })))), e.modifiersData.arrow != null && (e.styles.arrow = Object.assign({}, e.styles.arrow, Fe(Object.assign({}, c, {
    offsets: e.modifiersData.arrow,
    position: "absolute",
    adaptive: !1,
    roundOffsets: o
  })))), e.attributes.popper = Object.assign({}, e.attributes.popper, {
    "data-popper-placement": e.placement
  });
}
const cs = {
  name: "computeStyles",
  enabled: !0,
  phase: "beforeWrite",
  fn: ls,
  data: {}
};
var Bt = {
  passive: !0
};
function ds(t) {
  var e = t.state, n = t.instance, i = t.options, s = i.scroll, r = s === void 0 ? !0 : s, a = i.resize, l = a === void 0 ? !0 : a, o = _(e.elements.popper), c = [].concat(e.scrollParents.reference, e.scrollParents.popper);
  return r && c.forEach(function(d) {
    d.addEventListener("scroll", n.update, Bt);
  }), l && o.addEventListener("resize", n.update, Bt), function() {
    r && c.forEach(function(d) {
      d.removeEventListener("scroll", n.update, Bt);
    }), l && o.removeEventListener("resize", n.update, Bt);
  };
}
const us = {
  name: "eventListeners",
  enabled: !0,
  phase: "write",
  fn: function() {
  },
  effect: ds,
  data: {}
};
var hs = {
  left: "right",
  right: "left",
  bottom: "top",
  top: "bottom"
};
function Vt(t) {
  return t.replace(/left|right|bottom|top/g, function(e) {
    return hs[e];
  });
}
var fs = {
  start: "end",
  end: "start"
};
function Be(t) {
  return t.replace(/start|end/g, function(e) {
    return fs[e];
  });
}
function ye(t) {
  var e = _(t), n = e.pageXOffset, i = e.pageYOffset;
  return {
    scrollLeft: n,
    scrollTop: i
  };
}
function we(t) {
  return gt(Z(t)).left + ye(t).scrollLeft;
}
function ps(t, e) {
  var n = _(t), i = Z(t), s = n.visualViewport, r = i.clientWidth, a = i.clientHeight, l = 0, o = 0;
  if (s) {
    r = s.width, a = s.height;
    var c = fn();
    (c || !c && e === "fixed") && (l = s.offsetLeft, o = s.offsetTop);
  }
  return {
    width: r,
    height: a,
    x: l + we(t),
    y: o
  };
}
function gs(t) {
  var e, n = Z(t), i = ye(t), s = (e = t.ownerDocument) == null ? void 0 : e.body, r = st(n.scrollWidth, n.clientWidth, s ? s.scrollWidth : 0, s ? s.clientWidth : 0), a = st(n.scrollHeight, n.clientHeight, s ? s.scrollHeight : 0, s ? s.clientHeight : 0), l = -i.scrollLeft + we(t), o = -i.scrollTop;
  return G(s || n).direction === "rtl" && (l += st(n.clientWidth, s ? s.clientWidth : 0) - r), {
    width: r,
    height: a,
    x: l,
    y: o
  };
}
function $e(t) {
  var e = G(t), n = e.overflow, i = e.overflowX, s = e.overflowY;
  return /auto|scroll|overlay|hidden/.test(n + s + i);
}
function bn(t) {
  return ["html", "body", "#document"].indexOf(z(t)) >= 0 ? t.ownerDocument.body : F(t) && $e(t) ? t : bn(Qt(t));
}
function Ct(t, e) {
  var n;
  e === void 0 && (e = []);
  var i = bn(t), s = i === ((n = t.ownerDocument) == null ? void 0 : n.body), r = _(i), a = s ? [r].concat(r.visualViewport || [], $e(i) ? i : []) : i, l = e.concat(a);
  return s ? l : (
    // $FlowFixMe[incompatible-call]: isBody tells us target will be an HTMLElement here
    l.concat(Ct(Qt(a)))
  );
}
function oe(t) {
  return Object.assign({}, t, {
    left: t.x,
    top: t.y,
    right: t.x + t.width,
    bottom: t.y + t.height
  });
}
function ms(t, e) {
  var n = gt(t, !1, e === "fixed");
  return n.top = n.top + t.clientTop, n.left = n.left + t.clientLeft, n.bottom = n.top + t.clientHeight, n.right = n.left + t.clientWidth, n.width = t.clientWidth, n.height = t.clientHeight, n.x = n.left, n.y = n.top, n;
}
function Re(t, e, n) {
  return e === un ? oe(ps(t, n)) : rt(e) ? ms(e, n) : oe(gs(Z(t)));
}
function vs(t) {
  var e = Ct(Qt(t)), n = ["absolute", "fixed"].indexOf(G(t).position) >= 0, i = n && F(t) ? Pt(t) : t;
  return rt(i) ? e.filter(function(s) {
    return rt(s) && pn(s, i) && z(s) !== "body";
  }) : [];
}
function bs(t, e, n, i) {
  var s = e === "clippingParents" ? vs(t) : [].concat(e), r = [].concat(s, [n]), a = r[0], l = r.reduce(function(o, c) {
    var d = Re(t, c, i);
    return o.top = st(d.top, o.top), o.right = zt(d.right, o.right), o.bottom = zt(d.bottom, o.bottom), o.left = st(d.left, o.left), o;
  }, Re(t, a, i));
  return l.width = l.right - l.left, l.height = l.bottom - l.top, l.x = l.left, l.y = l.top, l;
}
function yn(t) {
  var e = t.reference, n = t.element, i = t.placement, s = i ? J(i) : null, r = i ? mt(i) : null, a = e.x + e.width / 2 - n.width / 2, l = e.y + e.height / 2 - n.height / 2, o;
  switch (s) {
    case W:
      o = {
        x: a,
        y: e.y - n.height
      };
      break;
    case B:
      o = {
        x: a,
        y: e.y + e.height
      };
      break;
    case R:
      o = {
        x: e.x + e.width,
        y: l
      };
      break;
    case j:
      o = {
        x: e.x - n.width,
        y: l
      };
      break;
    default:
      o = {
        x: e.x,
        y: e.y
      };
  }
  var c = s ? be(s) : null;
  if (c != null) {
    var d = c === "y" ? "height" : "width";
    switch (r) {
      case ft:
        o[c] = o[c] - (e[d] / 2 - n[d] / 2);
        break;
      case It:
        o[c] = o[c] + (e[d] / 2 - n[d] / 2);
        break;
    }
  }
  return o;
}
function St(t, e) {
  e === void 0 && (e = {});
  var n = e, i = n.placement, s = i === void 0 ? t.placement : i, r = n.strategy, a = r === void 0 ? t.strategy : r, l = n.boundary, o = l === void 0 ? Ni : l, c = n.rootBoundary, d = c === void 0 ? un : c, b = n.elementContext, v = b === void 0 ? yt : b, h = n.altBoundary, $ = h === void 0 ? !1 : h, u = n.padding, w = u === void 0 ? 0 : u, E = mn(typeof w != "number" ? w : vn(w, Dt)), L = v === yt ? _i : yt, O = t.rects.popper, f = t.elements[$ ? L : v], y = bs(rt(f) ? f : f.contextElement || Z(t.elements.popper), o, d, a), x = gt(t.elements.reference), k = yn({
    reference: x,
    element: O,
    strategy: "absolute",
    placement: s
  }), T = oe(Object.assign({}, O, k)), A = v === yt ? T : x, C = {
    top: y.top - A.top + E.top,
    bottom: A.bottom - y.bottom + E.bottom,
    left: y.left - A.left + E.left,
    right: A.right - y.right + E.right
  }, I = t.modifiersData.offset;
  if (v === yt && I) {
    var H = I[s];
    Object.keys(C).forEach(function(P) {
      var U = [R, B].indexOf(P) >= 0 ? 1 : -1, X = [W, B].indexOf(P) >= 0 ? "y" : "x";
      C[P] += H[X] * U;
    });
  }
  return C;
}
function ys(t, e) {
  e === void 0 && (e = {});
  var n = e, i = n.placement, s = n.boundary, r = n.rootBoundary, a = n.padding, l = n.flipVariations, o = n.allowedAutoPlacements, c = o === void 0 ? hn : o, d = mt(i), b = d ? l ? Ne : Ne.filter(function($) {
    return mt($) === d;
  }) : Dt, v = b.filter(function($) {
    return c.indexOf($) >= 0;
  });
  v.length === 0 && (v = b);
  var h = v.reduce(function($, u) {
    return $[u] = St(t, {
      placement: u,
      boundary: s,
      rootBoundary: r,
      padding: a
    })[J(u)], $;
  }, {});
  return Object.keys(h).sort(function($, u) {
    return h[$] - h[u];
  });
}
function ws(t) {
  if (J(t) === ge)
    return [];
  var e = Vt(t);
  return [Be(t), e, Be(e)];
}
function $s(t) {
  var e = t.state, n = t.options, i = t.name;
  if (!e.modifiersData[i]._skip) {
    for (var s = n.mainAxis, r = s === void 0 ? !0 : s, a = n.altAxis, l = a === void 0 ? !0 : a, o = n.fallbackPlacements, c = n.padding, d = n.boundary, b = n.rootBoundary, v = n.altBoundary, h = n.flipVariations, $ = h === void 0 ? !0 : h, u = n.allowedAutoPlacements, w = e.options.placement, E = J(w), L = E === w, O = o || (L || !$ ? [Vt(w)] : ws(w)), f = [w].concat(O).reduce(function(tt, K) {
      return tt.concat(J(K) === ge ? ys(e, {
        placement: K,
        boundary: d,
        rootBoundary: b,
        padding: c,
        flipVariations: $,
        allowedAutoPlacements: u
      }) : K);
    }, []), y = e.rects.reference, x = e.rects.popper, k = /* @__PURE__ */ new Map(), T = !0, A = f[0], C = 0; C < f.length; C++) {
      var I = f[C], H = J(I), P = mt(I) === ft, U = [W, B].indexOf(H) >= 0, X = U ? "width" : "height", N = St(e, {
        placement: I,
        boundary: d,
        rootBoundary: b,
        altBoundary: v,
        padding: c
      }), V = U ? P ? R : j : P ? B : W;
      y[X] > x[X] && (V = Vt(V));
      var qt = Vt(V), Y = [];
      if (r && Y.push(N[H] <= 0), l && Y.push(N[V] <= 0, N[qt] <= 0), Y.every(function(tt) {
        return tt;
      })) {
        A = I, T = !1;
        break;
      }
      k.set(I, Y);
    }
    if (T)
      for (var Mt = $ ? 3 : 1, Zt = function(tt) {
        var K = f.find(function(jt) {
          var bt = k.get(jt);
          if (bt)
            return bt.slice(0, tt).every(function(ot) {
              return ot;
            });
        });
        if (K)
          return A = K, "break";
      }, vt = Mt; vt > 0; vt--) {
        var Wt = Zt(vt);
        if (Wt === "break")
          break;
      }
    e.placement !== A && (e.modifiersData[i]._skip = !0, e.placement = A, e.reset = !0);
  }
}
const Es = {
  name: "flip",
  enabled: !0,
  phase: "main",
  fn: $s,
  requiresIfExists: ["offset"],
  data: {
    _skip: !1
  }
};
function He(t, e, n) {
  return n === void 0 && (n = {
    x: 0,
    y: 0
  }), {
    top: t.top - e.height - n.y,
    right: t.right - e.width + n.x,
    bottom: t.bottom - e.height + n.y,
    left: t.left - e.width - n.x
  };
}
function Ve(t) {
  return [W, R, B, j].some(function(e) {
    return t[e] >= 0;
  });
}
function xs(t) {
  var e = t.state, n = t.name, i = e.rects.reference, s = e.rects.popper, r = e.modifiersData.preventOverflow, a = St(e, {
    elementContext: "reference"
  }), l = St(e, {
    altBoundary: !0
  }), o = He(a, i), c = He(l, s, r), d = Ve(o), b = Ve(c);
  e.modifiersData[n] = {
    referenceClippingOffsets: o,
    popperEscapeOffsets: c,
    isReferenceHidden: d,
    hasPopperEscaped: b
  }, e.attributes.popper = Object.assign({}, e.attributes.popper, {
    "data-popper-reference-hidden": d,
    "data-popper-escaped": b
  });
}
const Ls = {
  name: "hide",
  enabled: !0,
  phase: "main",
  requiresIfExists: ["preventOverflow"],
  fn: xs
};
function Os(t, e, n) {
  var i = J(t), s = [j, W].indexOf(i) >= 0 ? -1 : 1, r = typeof n == "function" ? n(Object.assign({}, e, {
    placement: t
  })) : n, a = r[0], l = r[1];
  return a = a || 0, l = (l || 0) * s, [j, R].indexOf(i) >= 0 ? {
    x: l,
    y: a
  } : {
    x: a,
    y: l
  };
}
function ks(t) {
  var e = t.state, n = t.options, i = t.name, s = n.offset, r = s === void 0 ? [0, 0] : s, a = hn.reduce(function(d, b) {
    return d[b] = Os(b, e.rects, r), d;
  }, {}), l = a[e.placement], o = l.x, c = l.y;
  e.modifiersData.popperOffsets != null && (e.modifiersData.popperOffsets.x += o, e.modifiersData.popperOffsets.y += c), e.modifiersData[i] = a;
}
const Ts = {
  name: "offset",
  enabled: !0,
  phase: "main",
  requires: ["popperOffsets"],
  fn: ks
};
function As(t) {
  var e = t.state, n = t.name;
  e.modifiersData[n] = yn({
    reference: e.rects.reference,
    element: e.rects.popper,
    strategy: "absolute",
    placement: e.placement
  });
}
const Cs = {
  name: "popperOffsets",
  enabled: !0,
  phase: "read",
  fn: As,
  data: {}
};
function Is(t) {
  return t === "x" ? "y" : "x";
}
function Ss(t) {
  var e = t.state, n = t.options, i = t.name, s = n.mainAxis, r = s === void 0 ? !0 : s, a = n.altAxis, l = a === void 0 ? !1 : a, o = n.boundary, c = n.rootBoundary, d = n.altBoundary, b = n.padding, v = n.tether, h = v === void 0 ? !0 : v, $ = n.tetherOffset, u = $ === void 0 ? 0 : $, w = St(e, {
    boundary: o,
    rootBoundary: c,
    padding: b,
    altBoundary: d
  }), E = J(e.placement), L = mt(e.placement), O = !L, f = be(E), y = Is(f), x = e.modifiersData.popperOffsets, k = e.rects.reference, T = e.rects.popper, A = typeof u == "function" ? u(Object.assign({}, e.rects, {
    placement: e.placement
  })) : u, C = typeof A == "number" ? {
    mainAxis: A,
    altAxis: A
  } : Object.assign({
    mainAxis: 0,
    altAxis: 0
  }, A), I = e.modifiersData.offset ? e.modifiersData.offset[e.placement] : null, H = {
    x: 0,
    y: 0
  };
  if (x) {
    if (r) {
      var P, U = f === "y" ? W : j, X = f === "y" ? B : R, N = f === "y" ? "height" : "width", V = x[f], qt = V + w[U], Y = V - w[X], Mt = h ? -T[N] / 2 : 0, Zt = L === ft ? k[N] : T[N], vt = L === ft ? -T[N] : -k[N], Wt = e.elements.arrow, tt = h && Wt ? ve(Wt) : {
        width: 0,
        height: 0
      }, K = e.modifiersData["arrow#persistent"] ? e.modifiersData["arrow#persistent"].padding : gn(), jt = K[U], bt = K[X], ot = At(0, k[N], tt[N]), En = O ? k[N] / 2 - Mt - ot - jt - C.mainAxis : Zt - ot - jt - C.mainAxis, xn = O ? -k[N] / 2 + Mt + ot + bt + C.mainAxis : vt + ot + bt + C.mainAxis, Ut = e.elements.arrow && Pt(e.elements.arrow), Ln = Ut ? f === "y" ? Ut.clientTop || 0 : Ut.clientLeft || 0 : 0, xe = (P = I == null ? void 0 : I[f]) != null ? P : 0, On = V + En - xe - Ln, kn = V + xn - xe, Le = At(h ? zt(qt, On) : qt, V, h ? st(Y, kn) : Y);
      x[f] = Le, H[f] = Le - V;
    }
    if (l) {
      var Oe, Tn = f === "x" ? W : j, An = f === "x" ? B : R, et = x[y], Nt = y === "y" ? "height" : "width", ke = et + w[Tn], Te = et - w[An], Xt = [W, j].indexOf(E) !== -1, Ae = (Oe = I == null ? void 0 : I[y]) != null ? Oe : 0, Ce = Xt ? ke : et - k[Nt] - T[Nt] - Ae + C.altAxis, Ie = Xt ? et + k[Nt] + T[Nt] - Ae - C.altAxis : Te, Se = h && Xt ? es(Ce, et, Ie) : At(h ? Ce : ke, et, h ? Ie : Te);
      x[y] = Se, H[y] = Se - et;
    }
    e.modifiersData[i] = H;
  }
}
const Ds = {
  name: "preventOverflow",
  enabled: !0,
  phase: "main",
  fn: Ss,
  requiresIfExists: ["offset"]
};
function Ps(t) {
  return {
    scrollLeft: t.scrollLeft,
    scrollTop: t.scrollTop
  };
}
function qs(t) {
  return t === _(t) || !F(t) ? ye(t) : Ps(t);
}
function Ms(t) {
  var e = t.getBoundingClientRect(), n = pt(e.width) / t.offsetWidth || 1, i = pt(e.height) / t.offsetHeight || 1;
  return n !== 1 || i !== 1;
}
function Ws(t, e, n) {
  n === void 0 && (n = !1);
  var i = F(e), s = F(e) && Ms(e), r = Z(e), a = gt(t, s, n), l = {
    scrollLeft: 0,
    scrollTop: 0
  }, o = {
    x: 0,
    y: 0
  };
  return (i || !i && !n) && ((z(e) !== "body" || // https://github.com/popperjs/popper-core/issues/1078
  $e(r)) && (l = qs(e)), F(e) ? (o = gt(e, !0), o.x += e.clientLeft, o.y += e.clientTop) : r && (o.x = we(r))), {
    x: a.left + l.scrollLeft - o.x,
    y: a.top + l.scrollTop - o.y,
    width: a.width,
    height: a.height
  };
}
function js(t) {
  var e = /* @__PURE__ */ new Map(), n = /* @__PURE__ */ new Set(), i = [];
  t.forEach(function(r) {
    e.set(r.name, r);
  });
  function s(r) {
    n.add(r.name);
    var a = [].concat(r.requires || [], r.requiresIfExists || []);
    a.forEach(function(l) {
      if (!n.has(l)) {
        var o = e.get(l);
        o && s(o);
      }
    }), i.push(r);
  }
  return t.forEach(function(r) {
    n.has(r.name) || s(r);
  }), i;
}
function Ns(t) {
  var e = js(t);
  return Qi.reduce(function(n, i) {
    return n.concat(e.filter(function(s) {
      return s.phase === i;
    }));
  }, []);
}
function _s(t) {
  var e;
  return function() {
    return e || (e = new Promise(function(n) {
      Promise.resolve().then(function() {
        e = void 0, n(t());
      });
    })), e;
  };
}
function Fs(t) {
  var e = t.reduce(function(n, i) {
    var s = n[i.name];
    return n[i.name] = s ? Object.assign({}, s, i, {
      options: Object.assign({}, s.options, i.options),
      data: Object.assign({}, s.data, i.data)
    }) : i, n;
  }, {});
  return Object.keys(e).map(function(n) {
    return e[n];
  });
}
var Je = {
  placement: "bottom",
  modifiers: [],
  strategy: "absolute"
};
function ze() {
  for (var t = arguments.length, e = new Array(t), n = 0; n < t; n++)
    e[n] = arguments[n];
  return !e.some(function(i) {
    return !(i && typeof i.getBoundingClientRect == "function");
  });
}
function Bs(t) {
  t === void 0 && (t = {});
  var e = t, n = e.defaultModifiers, i = n === void 0 ? [] : n, s = e.defaultOptions, r = s === void 0 ? Je : s;
  return function(a, l, o) {
    o === void 0 && (o = r);
    var c = {
      placement: "bottom",
      orderedModifiers: [],
      options: Object.assign({}, Je, r),
      modifiersData: {},
      elements: {
        reference: a,
        popper: l
      },
      attributes: {},
      styles: {}
    }, d = [], b = !1, v = {
      state: c,
      setOptions: function(u) {
        var w = typeof u == "function" ? u(c.options) : u;
        $(), c.options = Object.assign({}, r, c.options, w), c.scrollParents = {
          reference: rt(a) ? Ct(a) : a.contextElement ? Ct(a.contextElement) : [],
          popper: Ct(l)
        };
        var E = Ns(Fs([].concat(i, c.options.modifiers)));
        return c.orderedModifiers = E.filter(function(L) {
          return L.enabled;
        }), h(), v.update();
      },
      // Sync update – it will always be executed, even if not necessary. This
      // is useful for low frequency updates where sync behavior simplifies the
      // logic.
      // For high frequency updates (e.g. `resize` and `scroll` events), always
      // prefer the async Popper#update method
      forceUpdate: function() {
        if (!b) {
          var u = c.elements, w = u.reference, E = u.popper;
          if (ze(w, E)) {
            c.rects = {
              reference: Ws(w, Pt(E), c.options.strategy === "fixed"),
              popper: ve(E)
            }, c.reset = !1, c.placement = c.options.placement, c.orderedModifiers.forEach(function(T) {
              return c.modifiersData[T.name] = Object.assign({}, T.data);
            });
            for (var L = 0; L < c.orderedModifiers.length; L++) {
              if (c.reset === !0) {
                c.reset = !1, L = -1;
                continue;
              }
              var O = c.orderedModifiers[L], f = O.fn, y = O.options, x = y === void 0 ? {} : y, k = O.name;
              typeof f == "function" && (c = f({
                state: c,
                options: x,
                name: k,
                instance: v
              }) || c);
            }
          }
        }
      },
      // Async and optimistically optimized update – it will not be executed if
      // not necessary (debounced to run at most once-per-tick)
      update: _s(function() {
        return new Promise(function(u) {
          v.forceUpdate(), u(c);
        });
      }),
      destroy: function() {
        $(), b = !0;
      }
    };
    if (!ze(a, l))
      return v;
    v.setOptions(o).then(function(u) {
      !b && o.onFirstUpdate && o.onFirstUpdate(u);
    });
    function h() {
      c.orderedModifiers.forEach(function(u) {
        var w = u.name, E = u.options, L = E === void 0 ? {} : E, O = u.effect;
        if (typeof O == "function") {
          var f = O({
            state: c,
            name: w,
            instance: v,
            options: L
          }), y = function() {
          };
          d.push(f || y);
        }
      });
    }
    function $() {
      d.forEach(function(u) {
        return u();
      }), d = [];
    }
    return v;
  };
}
var Rs = [us, Cs, cs, Xi, Ts, Es, Ds, rs, Ls], Hs = /* @__PURE__ */ Bs({
  defaultModifiers: Rs
});
async function ae(t) {
  if (!t)
    return this.collection;
  const e = this.collection.findIndex((n) => n.id === t.id);
  if (e >= 0) {
    const n = this.collection[e];
    n.state === "opened" && n.close(), n.popper.destroy(), wn(n), Object.getOwnPropertyNames(n).forEach((i) => {
      delete n[i];
    }), this.collection.splice(e, 1);
  }
  return this.collection;
}
function wn(t) {
  return t.__eventListeners && (t.__eventListeners.forEach((e) => {
    e.el.forEach((n) => {
      e.type.forEach((i) => {
        t[n].removeEventListener(i, e.listener, !1);
      });
    });
  }), delete t.__eventListeners), t;
}
async function Ee(t) {
  const e = on.call(this, t);
  return e.el.classList.add(this.settings.stateActive), e.trigger.hasAttribute("aria-controls") && e.trigger.setAttribute("aria-expanded", "true"), e.config = rn(e.el, this.settings), e.popper.setOptions({
    placement: e.config.placement,
    modifiers: [
      { name: "eventListeners", enabled: !0 },
      ...qi(e.config)
    ]
  }), e.popper.update(), e.state = "opened", e;
}
async function Vs(t, e) {
  ae.call(this, t);
  const n = this, i = {
    open() {
      return Ee.call(n, this);
    },
    close() {
      return pe.call(n, this);
    },
    deregister() {
      return ae.call(n, this);
    }
  }, s = {
    id: t.id,
    state: "closed",
    el: t,
    trigger: e,
    popper: Hs(e, t),
    config: rn(t, this.settings),
    ...i
  };
  return s.trigger.hasAttribute("aria-controls") && s.trigger.setAttribute("aria-expanded", "false"), $n.call(this, s), this.collection.push(s), s.el.classList.contains(this.settings.stateActive) && (await s.open(), dn.call(this, s)), s;
}
function $n(t) {
  return t.__eventListeners || (t.config.event === "hover" ? (t.__eventListeners = [{
    el: ["trigger"],
    type: ["mouseenter", "focus"],
    listener: Ee.bind(this, t)
  }, {
    el: ["el", "trigger"],
    type: ["mouseleave", "focusout"],
    listener: cn.bind(this, t)
  }], t.__eventListeners.forEach((e) => {
    e.el.forEach((n) => {
      e.type.forEach((i) => {
        t[n].addEventListener(i, e.listener, !1);
      });
    });
  })) : (t.__eventListeners = [{
    el: ["trigger"],
    type: ["click"],
    listener: Wi.bind(this, t)
  }], t.__eventListeners.forEach((e) => {
    e.el.forEach((n) => {
      e.type.forEach((i) => {
        t[n].addEventListener(i, e.listener, !1);
      });
    });
  }))), t;
}
var Tt;
class nr extends Si {
  constructor(e) {
    super(), Ci(this, Tt, void 0), this.defaults = Pi, this.settings = { ...this.defaults, ...e }, this.trigger = null, Ii(this, Tt, ji.bind(this)), this.settings.autoInit && this.init();
  }
  async init(e) {
    e && (this.settings = { ...this.settings, ...e });
    const n = document.querySelectorAll(this.settings.selectorPopover);
    return await this.registerCollection(n), this.settings.eventListeners && this.initEventListeners(!1), this;
  }
  async destroy() {
    return this.trigger = null, await this.deregisterCollection(), this.settings.eventListeners && this.destroyEventListeners(!1), this;
  }
  initEventListeners(e = !0) {
    e && this.collection.forEach((n) => {
      $n.call(this, n);
    }), document.addEventListener("keydown", je(this, Tt), !1);
  }
  destroyEventListeners(e = !0) {
    e && this.collection.forEach((n) => {
      wn(n);
    }), document.removeEventListener("keydown", je(this, Tt), !1);
  }
  register(e) {
    const n = Mi.call(this, e);
    return n.error ? Promise.reject(n.error) : Vs.call(this, n.popover, n.trigger);
  }
  deregister(e) {
    const n = this.get(an.call(this, e));
    return ae.call(this, n);
  }
  open(e) {
    return Ee.call(this, e);
  }
  close(e) {
    return pe.call(this, e);
  }
}
Tt = /* @__PURE__ */ new WeakMap();
export {
  Xs as Drawer,
  er as Modal,
  nr as Popover,
  Gs as core
};
//# sourceMappingURL=index.js.map
